"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _components = _interopRequireDefault(require("prismjs/components.js"));

var _dependencies = _interopRequireDefault(require("prismjs/dependencies.js"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

var getPath = function getPath(type) {
  return function (name) {
    return "prismjs/".concat(_components["default"][type].meta.path.replace(/\{id\}/g, name));
  };
};

var isPlugin = function isPlugin(dep) {
  return _components["default"].plugins[dep] != null;
};

var getNoCSS = function getNoCSS(type, name) {
  return _components["default"][type][name].noCSS;
};

var getThemePath = function getThemePath(theme) {
  if (theme === 'default') {
    theme = 'prism';
  } else {
    theme = "prism-".concat(theme);
  }

  return getPath('themes')(theme);
};

var getPluginPath = getPath('plugins');
var getLanguagePath = getPath('languages');

var _default = function _default() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      _ref$languages = _ref.languages,
      languages = _ref$languages === void 0 ? [] : _ref$languages,
      _ref$plugins = _ref.plugins,
      plugins = _ref$plugins === void 0 ? [] : _ref$plugins,
      theme = _ref.theme,
      _ref$css = _ref.css,
      css = _ref$css === void 0 ? false : _ref$css;

  return [].concat(_toConsumableArray((0, _dependencies["default"])(_components["default"], [].concat(_toConsumableArray(languages), _toConsumableArray(plugins))).getIds().reduce(function (deps, dep) {
    // Plugins can have language dependencies.
    var add = [isPlugin(dep) ? getPluginPath(dep) : getLanguagePath(dep)];

    if (css && isPlugin(dep) && !getNoCSS('plugins', dep)) {
      add.unshift(getPluginPath(dep) + '.css');
    }

    return [].concat(_toConsumableArray(deps), add);
  }, [])), _toConsumableArray(css && theme ? [getThemePath(theme)] : []));
};

exports["default"] = _default;