'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _postcss = require('postcss');

var _postcss2 = _interopRequireDefault(_postcss);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var postcssFlexibility = _postcss2.default.plugin('postcss-flexibility', function () {
	return function (css) {
		css.walkRules(function (rule) {
			var isDisabled = rule.some(function (_ref) {
				var prop = _ref.prop,
				    _ref$text = _ref.text,
				    text = _ref$text === undefined ? '' : _ref$text;
				return prop === '-js-display' || text.endsWith('flexibility-disable');
			});

			if (!isDisabled) {
				rule.walkDecls('display', function (decl) {
					var value = decl.value;

					if (/^flex$|^inline-flex$/.test(value)) {
						decl.cloneBefore({ prop: '-js-display' });
					}
				});
			}
		});
	};
});

exports.default = postcssFlexibility;
module.exports = exports['default'];
